//+---TRO_MOMO_REVERSALS----------------------------------+
 

//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 8
#property indicator_color1 Aqua
#property indicator_color2 Magenta
#property indicator_minimum 0
#property indicator_maximum 4

extern bool   mySound.Alert    = FALSE ;
//extern bool   myComment    = true ;
  
extern int myBars1 = 30; 


extern color myBarColorUp   = Aqua;
extern color myBarColorDown = Magenta;
extern color myBarColorWait = DimGray;


int myBarWidth = 0;
int myWingding = 110;// 112

double BUY10[];
double SELL10[];
 
 
//---- indicator buffers
double     MBuffer[];
double     SBuffer[];
double     WAIT10[];
double     SELL20[];
double     BUY30[];
double     SELL30[];


string symbol, tChartPeriod,  tShortName ;  
int    digits, period  ; 
datetime Trigger ;

//---- variables

string tTrade = "" ;   
color tColor    = White;
string tObjName01   ;
int      corner;
int      window; 
string   shortName;
int      win ;  

bool sFirst;

 


double point, pos = 1, pos1 = 2 , pos2 = 1 , ohigh, olow, chigh, clow, high, low;  

double Open0, Open1, Open2, Close0, Close1, Close2, High0, High1, High2, Low0,  Low1, Low2, Range0, Range1, Range2  ;
double Open3, Close3, High3, Low3, Body0, Body1, Body2, Body3, VALUE;

bool FILLED = false, GREEN0, GREEN1, GREEN2, GREEN3,GOLONG1, GOSHORT1 , GOLONG2, GOSHORT2 , GOLONG3, GOSHORT3;

 
   int arrowUP=233;
   int arrowDN=234;  

   int  nMin, nMax,  nHH, nLL;
//+------------------------------------------------------------------+
int init()
  {
  
  sFirst = true ;
   
   period       =  Period() ;     
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;
   
   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }    
   
   
   shortName  = "MOMO REVERSALS "+  Symbol()  ;
   tObjName01 = shortName +  "0" ;


   IndicatorShortName(shortName);  

//---- indicators
   SetIndexStyle(0,DRAW_ARROW,0,myBarWidth,myBarColorUp);
   SetIndexArrow(0,arrowUP);
   SetIndexBuffer(0,BUY10);

   
   SetIndexStyle(1,DRAW_ARROW,0,myBarWidth,myBarColorDown);
   SetIndexArrow(1,arrowDN);
   SetIndexBuffer(1,SELL10);
     

   SetIndexStyle(2,DRAW_NONE,0,myBarWidth,myBarColorWait);
   SetIndexArrow(2,myWingding);
   SetIndexBuffer(2,WAIT10);
 
   IndicatorDigits(0);
   
   
   return(0);
  }
  
//+------------------------------------------------------------------+
int deinit()
  {
 
  Comment("") ;
   return(0);
  }
     
//+------------------------------------------------------------------+
int start()
  {
  
  
  
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   
   if(FILLED) { limit=Bars-counted_bars; }
   else { limit = Bars ; }
   


   for(int i=0; i<limit; i++)
   {
      SELL10[i]  = EMPTY_VALUE;
      BUY10[i]   = EMPTY_VALUE; 
      WAIT10[i]  = EMPTY_VALUE;
  
      DoWork( i ) ;
 
      if ( GOLONG1 )  { BUY10[i]  = Low0 ; }
      else 
      if ( GOSHORT1 ) { SELL10[i] = High0 ; }
//      else 
//      { WAIT10[i] = pos ; }   
            
   }

   if( i > 100 ) { FILLED = true ; }

  if (  Trigger != Time[0] && mySound.Alert ) // Trigger != Time[0] && 
  {
        if( BUY10[1]  == pos ) { Trigger = Time[0] ; Alert(symbol,"  ", tChartPeriod, " 1 BUY!  "+ DoubleToStr(Close[0] ,digits)); }
        if( SELL10[1] == pos ) { Trigger = Time[0] ; Alert(symbol,"  ", tChartPeriod, " 1 SELL SHORT! "+ DoubleToStr(Close[0] ,digits)); }     
  
  }



return(0);
}
//+------------------------------------------------------------------+
  
void DoWork(  int w )
{

   Close0 = iClose(symbol,period,0+w) ; 
   Close1 = iClose(symbol,period,1+w) ;    
   Close2 = iClose(symbol,period,2+w) ;  
   Close3 = iClose(symbol,period,3+w) ;  
           
   Open0 = iOpen(symbol,period,0+w) ; 
   Open1 = iOpen(symbol,period,1+w) ;    
   Open2 = iOpen(symbol,period,2+w) ;  
   Open3 = iOpen(symbol,period,3+w) ;  
   
   High0 = iHigh(symbol,period,0+w) ; 
   High1 = iHigh(symbol,period,1+w) ;    
   High2 = iHigh(symbol,period,2+w) ; 
   High3 = iHigh(symbol,period,3+w) ; 
   
   Low0 = iLow(symbol,period,0+w) ; 
   Low1 = iLow(symbol,period,1+w) ;    
   Low2 = iLow(symbol,period,2+w) ;    
   Low3 = iLow(symbol,period,3+w) ; 
   
   Range0 = High0 - Low0 ; 
   Range1 = High1 - Low1 ;    
   Range2 = High2 - Low2 ; 
      
   Body0 = MathAbs(Close0 - Open0) ; 
   Body1 = MathAbs(Close1 - Open1) ;     
   Body2 = MathAbs(Close2 - Open2) ;  
   Body3 = MathAbs(Close3 - Open3) ; 
   
   GREEN0 = Close0 > Open0 ; 
   GREEN1 = Close1 > Open1 ;
   GREEN2 = Close2 > Open2 ;   
   GREEN3 = Close3 > Open3 ; 
   
   VALUE   = Body2 + Body3 ;
   
   GOLONG1 = GREEN1 && !GREEN2 && !GREEN3 && Body1 > VALUE  ;  

   GOSHORT1 = !GREEN1 && GREEN2 && GREEN3 && Body1 > VALUE  ;  

} 
  
//+------------------------------------------------------------------+
 

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}
//+------------------------------------------------------------------+
/*

Comment(

"pair " , symbol , "\n" , 
"MBuffer[0] " , DoubleToStr(MBuffer[0],6) , "\n" ,
"SBuffer[0] " , DoubleToStr(SBuffer[0],6) , "\n" ,

"BUY10[0] " , DoubleToStr(BUY10[0],Digits) , "\n" ,
"BUY10[1] " , DoubleToStr(BUY10[1],Digits) , "\n" ,
"BUY10[2] " , DoubleToStr(BUY10[1],Digits) , "\n" ,
"SELL10[0] " , DoubleToStr(SELL10[0],Digits) , "\n" ,
"SELL10[1] " , DoubleToStr(SELL10[1],Digits) , "\n" ,
"SELL10[2] " , DoubleToStr(SELL10[1],Digits) , "\n" ,
"") ; 




if(myComment)
{
D1_Open  = iOpen(symbol,PERIOD_D1,0);  
D1_Close = iClose(symbol,PERIOD_D1,0);  
D1_high  = iHigh(symbol,PERIOD_D1,0);
D1_low   = iLow(symbol,PERIOD_D1,0);
D1_pivot = ( D1_Close + D1_high + D1_low ) / 3.0 ; 
D1_range = ( D1_high - D1_low ) / point ;
D1_ClOp  = ( D1_Close - D1_Open ) / point ;


Comment(

 "\n" , "Daily " ,  
"O=" , DoubleToStr(D1_Open,Digits) , " " ,
"H=" , DoubleToStr(D1_high,Digits) , " " ,
"L=" , DoubleToStr(D1_low,Digits) , " " ,
"C=" , DoubleToStr(D1_Close,Digits) , " " ,
"P=" , DoubleToStr(D1_pivot,Digits) , " " ,
"R=" , DoubleToStr(D1_range,0) , " " ,
"D=" , DoubleToStr(D1_ClOp,0) , " " ,

"") ; 
} // if(myComment)


*/