//+------------------------------------------------------------------+ 
//|   TRO_OPEN_DOTS                                                  | 
//|                                                                  | 
//|   Copyright  2011, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+  
//| Use http://therumpledone.mbtrading.com/forex.aspx as your forex  |  
//|  broker ...tell them therumpledone sent you!                     |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2011, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 
 

#property indicator_chart_window
#property indicator_buffers 8 
#property indicator_color1 Aqua
#property indicator_color2 Magenta
#property indicator_color3 Aqua
#property indicator_color4 Magenta
#property indicator_color5 Aqua
#property indicator_color6 Magenta
#property indicator_color7 Aqua
#property indicator_color8 Magenta 


extern bool   TurnOff  = false ; 
extern bool   Show.Legend  = true ;

extern int  myShift = 1 ;
 
extern int myStyle  = 0 ;
extern int myWidth  = 0 ; 

extern int myWingDing  = 119 ; // 171

extern color color_M1  = Gold ;
extern color color_M5  = Orange ;
extern color color_M15 = Red ;
extern color color_H1  = Chocolate ; 
extern color color_H4  = Indigo ;
extern color color_D1  = Purple ; 
extern color color_W1  = DarkGreen ;
extern color color_MN1 = DodgerBlue ;


 
//---- buffers 
double P0Buffer[], P1Buffer[], P2Buffer[], P3Buffer[], P4Buffer[], P5Buffer[], P6Buffer[], P7Buffer[];

string symbol, tChartPeriod, ShortName, tsymbol, TAG="OPDOTS" ;  

int     digits, period, win, digits2, n, j, i, w, barnum; 
 
double Ctl_Open, Ctl_Close, Ctl_High, Ctl_Low, Ctl_Diff, Ctl_Mid, Ctl_Pivot, Ctl_High1, Ctl_Low1, Ctl_Mid1;

double point ;   
                   
//+------------------------------------------------------------------+ 
int init() 
  { 
   period = Period() ;
  
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
 
   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
    
   SetIndexBuffer(0, P0Buffer);
   SetIndexArrow(0, myWingDing); 
   SetIndexStyle(0, DRAW_ARROW, myStyle, myWidth, color_M1 );
 
   SetIndexBuffer(1, P1Buffer);
   SetIndexArrow(1, myWingDing); 
   SetIndexStyle(1, DRAW_ARROW, myStyle, myWidth, color_M5 ); 
 
   SetIndexBuffer(2, P2Buffer);
   SetIndexArrow(2, myWingDing); 
   SetIndexStyle(2, DRAW_ARROW, myStyle, myWidth, color_M15 );
 
   SetIndexBuffer(3, P3Buffer);
   SetIndexArrow(3, myWingDing); 
   SetIndexStyle(3, DRAW_ARROW, myStyle, myWidth, color_H1 ); 

   SetIndexBuffer(4, P4Buffer);
   SetIndexArrow(4, myWingDing); 
   SetIndexStyle(4, DRAW_ARROW, myStyle, myWidth, color_H4 ); 

   SetIndexBuffer(5, P5Buffer);
   SetIndexArrow(5, myWingDing); 
   SetIndexStyle(5, DRAW_ARROW, myStyle, myWidth, color_D1 ); 

   SetIndexBuffer(6, P6Buffer);
   SetIndexArrow(6, myWingDing); 
   SetIndexStyle(6, DRAW_ARROW, myStyle, myWidth, color_W1 ); 
   

   SetIndexBuffer(7, P7Buffer);
   SetIndexArrow(7, myWingDing); 
   SetIndexStyle(7, DRAW_ARROW, myStyle, myWidth, color_MN1 );   
      
   TRO();
   return(0); 
  } 

//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
    
 //+------------------------------------------------------------------+ 
int deinit() 
{ 
   ObDeleteObjectsByPrefix(TAG);  
   
      TRO() ;
   return(0); 
} 
 //+------------------------------------------------------------------+ 
int start() 
  { 

if( TurnOff ) { return(0) ; }
   
   int    counted_bars=IndicatorCounted(); 
   if(counted_bars < 0) return(-1); 

   int limit=Bars-counted_bars-1; 

   for(int i=limit;i>=0;i--)
   { 
      barnum      = iBarShift(symbol,PERIOD_M1,Time[i+myShift]);
      P0Buffer[i] = iOpen(symbol,PERIOD_M1, barnum) ;

      barnum      = iBarShift(symbol,PERIOD_M5,Time[i+myShift]);      
      P1Buffer[i] = iOpen(symbol,PERIOD_M5, barnum) ;
      
      barnum      = iBarShift(symbol,PERIOD_M15,Time[i+myShift]);      
      P2Buffer[i] = iOpen(symbol,PERIOD_M15, barnum) ;
      
      barnum      = iBarShift(symbol,PERIOD_H1,Time[i+myShift]);      
      P3Buffer[i] = iOpen(symbol,PERIOD_H1, barnum) ;

      barnum      = iBarShift(symbol,PERIOD_H4,Time[i+myShift]);   
      P4Buffer[i] = iOpen(symbol,PERIOD_H4, barnum) ;  
      
      barnum      = iBarShift(symbol,PERIOD_D1,Time[i+myShift]);          
      P5Buffer[i] = iOpen(symbol,PERIOD_D1, barnum) ; 
      
      barnum      = iBarShift(symbol,PERIOD_W1,Time[i+myShift]);           
      P6Buffer[i] = iOpen(symbol,PERIOD_W1, barnum) ;
      
      barnum      = iBarShift(symbol,PERIOD_MN1,Time[i+myShift]);      
      P7Buffer[i] = iOpen(symbol,PERIOD_MN1, barnum) ;
                  
   } //end for 


      if(Show.Legend) { DoShowLegend(); }
   
   WindowRedraw() ;

   return(0); 
  } 

//+------------------------------------------------------------------+  
void DoShowLegend()
{ 
   setObject(TAG+"m1", "M1  Prev Open " + DoubleToStr(P0Buffer[0], digits) ,30,20,color_M1); 
   setObject(TAG+"m5", "M5  Prev Open " + DoubleToStr(P1Buffer[0], digits) ,30,33,color_M5); 
   setObject(TAG+"m15","M15 Prev Open " + DoubleToStr(P2Buffer[0], digits) ,30,46,color_M15); 
   setObject(TAG+"h1", "H1  Prev Open " + DoubleToStr(P3Buffer[0], digits) ,30,59,color_H1); 
   setObject(TAG+"h4", "H4  Prev Open " + DoubleToStr(P4Buffer[0], digits) ,30,72,color_H4); 
   setObject(TAG+"d1", "D1  Prev Open " + DoubleToStr(P5Buffer[0], digits) ,30,85,color_D1);      
   setObject(TAG+"w1", "W1  Prev Open " + DoubleToStr(P6Buffer[0], digits) ,30,98,color_W1);      
   setObject(TAG+"mn", "MN  Prev Open " + DoubleToStr(P7Buffer[0], digits) ,30,111,color_MN1);         
            
}

//+------------------------------------------------------------------+  

void setObject(string labelName,string text,int x,int y,color theColor, string font = "Courier New",int size=10,int angle=0)
{
 
      
      if (ObjectFind(labelName) == -1)
          {
             ObjectCreate(labelName,OBJ_LABEL,0,0,0);
             ObjectSet(labelName,OBJPROP_CORNER,0);
             if (angle != 0)
                  ObjectSet(labelName,OBJPROP_ANGLE,angle);
          }               
       ObjectSet(labelName,OBJPROP_XDISTANCE,x);
       ObjectSet(labelName,OBJPROP_YDISTANCE,y);
       ObjectSetText(labelName,text,size,font,theColor);
}
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+ 
 
/*

*/

