//+------------------------------------------------------------------+
//|   TRO_WICKPCT                                                    | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 
#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 
 
           
#property indicator_separate_window
#property indicator_buffers 3

#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 Green 
 
extern int  LineStyle  =  0 ; 
extern int  LineWidth  =  3 ; 

extern color  WickColor  = Red ; 
extern color  BodyColor  = Blue ; 
extern color  TailColor  = Green ; 

extern color GridColor = DimGray;


//---- buffers

double P0Buffer[];
double P1Buffer[];
double P2Buffer[]; 
 

 
string short_name;
 
string symbol, tChartPeriod;  
int    digits, period , j=0, upHits, dnHits, passes ;    
double point, open, high, low, close, top, bottom, range ;
 
//+------------------------------------------------------------------+
int init()
{
  
   period       =  Period() ;  
   digits       =  Digits ;   
   point        =  Point ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
    
        
   short_name="TRO_wick%";
 
   IndicatorShortName(short_name);
 
   SetIndexBuffer(0, P0Buffer);
   SetIndexStyle(0, DRAW_LINE,LineStyle,LineWidth,WickColor );
   SetIndexBuffer(1, P1Buffer);
   SetIndexStyle(1, DRAW_LINE,LineStyle,LineWidth,BodyColor );
   SetIndexBuffer(2, P2Buffer);
   SetIndexStyle(2, DRAW_LINE,LineStyle,LineWidth,TailColor );
 
/*   
   SetLevelStyle(STYLE_DOT, 1, GridColor) ;
   SetLevelValue(1,50 );
   SetLevelValue(2,100 );   
   SetLevelValue(3,10 );
   SetLevelValue(4,0);
   SetLevelValue(5,-10 );
   SetLevelValue(6,-100 );
   SetLevelValue(7,-50 ); 
*/ 
   deinit() ;
   return(0);
}
       
//+------------------------------------------------------------------+
int deinit()
{
 
   TRO();
   return(0);
}
  
//+------------------------------------------------------------------+

int start()
{

   int i, dayi, counted_bars = IndicatorCounted();
//---- check for possible errors
   if(counted_bars < 0) 
       return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) 
       counted_bars--;  
   int limit = Bars - counted_bars;

 
   for(i = limit - 1; i >= 0; i--)
   {

      
      open  = iOpen(NULL,period,i);
      high  = iHigh(NULL,period,i);
      low   = iLow(NULL,period,i);
      close = iClose(NULL,period,i);
      range = high - low ;
      top   = MathMax(open, close);
      bottom = MathMin(open, close);
      if( range > 0 )
      {
         P0Buffer[i]  = (high - top) / range ;
         P1Buffer[i]  = (top - bottom) / range ;      
         P2Buffer[i]  = (bottom - low) / range ;     
      } 
      else
      {
         P0Buffer[i]  = EMPTY_VALUE ;
         P1Buffer[i]  = EMPTY_VALUE ;      
         P2Buffer[i]  = EMPTY_VALUE ;       
      }      
   } // for
 


Comment( 
"open = ", DoubleToStr(open , digits), "\n",        
"high = ", DoubleToStr(high , digits), "\n",  
"low = ", DoubleToStr(low , digits), "\n",  
"close = ", DoubleToStr(close , digits), "\n",        
"range = ", DoubleToStr(range , digits), "\n",  
"top = ", DoubleToStr(top , digits), "\n",  
"") ;
return(0);   
}


//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}  
//+------------------------------------------------------------------+   
 