//+------------------------------------------------------------------+ 
//|   TRO_Above_Below_Open                                           | 
//|                                                                  | 
//|   Copyright  2011, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/forex.aspx                |  
//| as your forex broker...tell them therumpledone sent you!         |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2011, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

//---- indicator settings 
#property indicator_chart_window
#property indicator_buffers 0


//---- indicator parameters  

extern bool SHOW.PRICE = true ; 
 
extern  bool Show.Help  = false ;
extern color colorHelp  = Orange ;

extern int win            = 0 ;
extern int CORNER         = 0 ;
extern int price.x.offset = 0 ;//250
extern int price.y.offset = 300 ;//-160

extern int   Chart_Period    = 0;
extern int   myBars          = 0 ;
extern int   myShift         = 1 ;

extern color Up_color = Lime;
extern color Eq_color = Yellow;
extern color Dn_color = Red;

extern color aboveColor = LightSteelBlue ;
extern color belowColor  = LightSteelBlue ;

color ClOpColor ;

string symbol, tPeriod, tLabel01, tLabel02, tLabel03, tLabel04, tLabel05 ;
double above, below, pctabove, pctbelow, open, close, openi, closei, highi, lowi, diff ; 
double MaxAbove, MaxBelow ;
int    limit, digits, period, digits2  ; 
double point ;

//+------------------------------------------------------------------+
color fColor( double i, double j)
{
color rColor ;

    if ( i > j ) rColor = Up_color; 
    else {
    if ( i < j )  rColor = Dn_color; 
    else rColor = Eq_color; }
    
return ( rColor );
}
 
 
//+------------------------------------------------------------------+ 

int init() 
  { 
   symbol       =  Symbol() ;
   if(Chart_Period == 0) { Chart_Period = Period() ; }

   tPeriod = " "+TimeFrameToString( Chart_Period ) ;
   
   digits       =  Digits ;   
   point        =  Point ;
   

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
     
    tLabel01 = "ABO1029"  ;
    tLabel02 = "ABO1030"  ;
    tLabel03 = "ABO1031"  ;
    tLabel04 = "ABO1034"  ;
    tLabel05 = "ABO1035"   ;

   deinit()  ; 

   if(Show.Help) { DoHelp () ; }  
   
return(0); 
} 


//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
  

//+------------------------------------------------------------------+ 

int deinit() 
{ 
   ObDeleteObjectsByPrefix("ABO1");  
   TRO();
}  
 

//+------------------------------------------------------------------+ 

int start() 
{ 
  
if(myBars == 0) { limit = WindowBarsPerChart() ;  } else { limit = myBars ; }
 

open   = iOpen(symbol,Chart_Period,0) ;    
close  = iClose(symbol,Chart_Period,0) ; 

MaxAbove = 0 ; 
MaxBelow = 0 ;


above = 0 ;
below = 0 ;

for(int i=myShift; i<=limit+myShift-1; i++) 
{ 
     openi  = iOpen(symbol,Chart_Period,i) ; 
     closei = iClose(symbol,Chart_Period,i) ; 
     highi  = iHigh(symbol,Chart_Period,i) ; 
     lowi   = iLow(symbol,Chart_Period,i) ; 
           
     if( openi > close ) {above = above  + 1  ; }
     if( openi < close ) {below = below  + 1  ; }
     
     diff = highi - close ;
     diff = NormalizeDouble(diff, digits) ;
     
     if( diff > MaxAbove ) {MaxAbove = diff ; }

     diff = close - lowi ;
     diff = NormalizeDouble(diff, digits) ;
     
     if( diff > MaxBelow ) {MaxBelow = diff ; }     
     
   } 


pctabove = ( above / limit ) * 100 ;
pctbelow = ( below / limit ) * 100 ;

string tpctabove = DoubleToStr(pctabove, 2 ) + "%" ;
string tpctbelow = DoubleToStr(pctbelow, 2 ) + "%" ;

string tmaxabove = DoubleToStr(MaxAbove / point , 0 )  ;
string tmaxbelow = DoubleToStr(MaxBelow / point , 0 )  ;


ClOpColor  = fColor( close, open ) ;
 

string tabove =  DoubleToStr(above, 0 ) + "/" + limit + " Open Above " + tpctabove + " Max+ " + tmaxabove ; 
string tbelow =  DoubleToStr(below, 0 ) + "/" + limit + " Open Below " + tpctbelow + " Max- " + tmaxbelow ; 
                     
   ObjectCreate(tLabel01, OBJ_LABEL, win, 0, 0); 
   ObjectSetText(tLabel01,tabove, 15, "Arial Bold", aboveColor );
   ObjectSet(tLabel01, OBJPROP_CORNER, CORNER);
   ObjectSet(tLabel01, OBJPROP_XDISTANCE, 0+price.x.offset);
   ObjectSet(tLabel01, OBJPROP_YDISTANCE, 37+price.y.offset);
   
  
   
   ObjectCreate(tLabel02, OBJ_LABEL, win, 0, 0); 
   ObjectSetText(tLabel02,tbelow, 15, "Arial Bold", belowColor );
   ObjectSet(tLabel02, OBJPROP_CORNER, CORNER);
   ObjectSet(tLabel02, OBJPROP_XDISTANCE, 0+price.x.offset);
   ObjectSet(tLabel02, OBJPROP_YDISTANCE, 100+price.y.offset); 
 
  if(SHOW.PRICE)
  {                                        
   ObjectCreate(tLabel03, OBJ_LABEL, win, 0, 0); 
   ObjectSetText(tLabel03,symbol + " " + DoubleToStr(close, digits ) +tPeriod , 30, "Arial Bold", ClOpColor );
   ObjectSet(tLabel03, OBJPROP_CORNER, CORNER);
   ObjectSet(tLabel03, OBJPROP_XDISTANCE, 0+price.x.offset); // 765
   ObjectSet(tLabel03, OBJPROP_YDISTANCE, 60+price.y.offset); 
  }      

   WindowRedraw();    
 
//} 

   return(0); 
} 

//+------------------------------------------------------------------+

 
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}
  

//+------------------------------------------------------------------+  

void DoHelp()
{


string aHelp[10];

aHelp[0] = "TRO_Above_Below" ;
aHelp[1] = " " ;
aHelp[2] = "Top line: #closes above current price / total# closes, %above, " ;
aHelp[3] = "Max pips above, Max pips above current price " ;
aHelp[4] = " " ;
aHelp[5] = "Middle line: Closing Price and period used " ;
aHelp[6] = "  " ;
aHelp[7] = "Bottom: #closes below current price / total# closes, %below,"  ;
aHelp[8] = "Max pips below, Max pips below current price " ;
aHelp[9] = "  " ;


for( int h = 0 ; h < 10 ; h++ )
{
   drawComment("ABOaHelp"+h,aHelp[h] , 10, 12 + 16*h , colorHelp  ) ;
} 

}

//+------------------------------------------------------------------+  
 
void drawComment(string tLabel,string name, int xPos, int yPos ,color Color  )
{

ObjectCreate(tLabel,23,0,Time[0],PRICE_CLOSE);
ObjectSet(tLabel, OBJPROP_CORNER, 0 );
ObjectSet(tLabel,OBJPROP_XDISTANCE,xPos);
ObjectSet(tLabel,OBJPROP_YDISTANCE,yPos);
ObjectSetText(tLabel,name,12,"Courier New",Color); 
}
 
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}
 
//+------------------------------------------------------------------+  