//+------------------------------------------------------------------+ 
//|   TRO_HL5                                                        | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window

extern bool   TurnOff  = false ; 

extern int myChartX   = 10 ;
extern int myChartY   = 300 ;  
  
extern int myCorner   = 1 ;
extern string myFont  = "Courier New" ;
extern int myFontSize = 12 ;

extern bool   Show.Open  = true ;
extern bool   Show.High  = true ;
extern bool   Show.Low   = true ;
extern bool   Show.Close = true ;
extern bool   Show.MidOC = true ;
extern bool   Show.All   = false ;


extern bool   Show.Gauge  = false ; 
extern bool   Show.Lines  = true ;
extern bool   Show.Labels = false ;
extern bool   Show.Volume = false ;

extern bool   Show.Smart  = false ;

extern int  ShiftLabel =  5 ;
extern int  LineStyle  =  0 ; 

extern int myPeriod = 0 ;

extern int myBars   = 24 ;
extern int myShift  = 1 ;
extern double myThreshold = 10 ;

extern color colorOpen   = Orange ;
extern color colorHOD    = Red ;
extern color colorLOD    = Blue ;
extern color colorClose  = Gold ;
extern color colorMidOC  = Aqua ;

extern color UpColor   = Lime;
extern color DownColor = Red;


//+------------------------------------------------------------------+

double Hi, Li, C, O;

double prev_open , prev_high, prev_low, prev_close, D, p, value ;
int h  ;
string lbl[15], lbl2[15];
int n, j, k ;

color pColor = Blue, VolColor = Magenta ;

string symbol, tChartPeriod, ShortName, TAG ;  
int    digits, period, win ; 
double point,  open, high, low, close, mid, range, pClose, pOpen, pHigh, pLow, pMid, pRange, cRange, PipDiff  ;  
double VolHH, VolLL, Vol, diff, OPEN, CLOSE , VALUE, VALUEA, VALUEB, MidOC;
string VolMsg;

int FillAmt = 11 , x001, x002, x003, x004, x005, x006, x007 ;   

int plotbars = 0, fill=9 ;

bool TestVol ;
//+------------------------------------------------------------------+

int init()
  {
   if(myPeriod == 0) { period = Period() ; } else { period = myPeriod ; }    
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   TAG          = "HL5" ; 
   ShortName    = TAG+symbol+period ;
   win          = 0 ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
 
   
if( myCorner == 0 || myCorner == 2 )
{ 
   x001 = 0 ;
   x002 = 0 ;
   x003 = 90 ; 
   x004 = 150;
   x005 = 100 ;
   x006 = 90 ;  
   x007 = 90 ;
   FillAmt = 20 ;     
}
else
{
   x001 = 0 ;
   x002 = 130 ; //  
   x003 = 50 ;  //  
   x004 = 0 ; //  
   x005 = 10 ;
   x006 = 10 ;  
   x007 = 10 ;   
   FillAmt = 20 ; 
}
        
  
  deinit();   
   
   return(0);
  }
  
  
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
    
//+------------------------------------------------------------------+
int deinit()
  {
    
   ObDeleteObjectsByPrefix(TAG);          
   TRO() ;
   
   return(0);
  }
  
//+------------------------------------------------------------------+
int start()
{

if( TurnOff ) { return(0) ; }

n       = 10;
j       = 0 ;

if(Show.Gauge) 
{
lbl[j]  = ShortName+j;
lbl2[j] = fFill(tChartPeriod + " HIGHs LOWs     +/-", 22) ;
DoShowHead(j, SteelBlue);
}

close    = iClose( symbol, 0, 0) ;

for( k = 0+myShift; k < myBars+myShift; k++ )
{

open     = iOpen( symbol, period, k ) ;
high     = iHigh( symbol, period, k ) ;
low      = iLow( symbol, period, k ) ;

 

VALUEB   = iOpen( symbol, period, k+1 ) ;
VALUE    = iOpen( symbol, period, k ) ;
VALUEA   = iOpen( symbol, period, k-1 ) ;

if( Show.All || ( !Show.All && ((VALUE > VALUEB && VALUE > VALUEA) || (VALUE < VALUEB && VALUE < VALUEA) ) ) )
{
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = fFill("Open(" + k + ") ",fill) ;
PipDiff = ( close - VALUE ) / point ; 
DoColor( close, VALUE  ) ; 
if(Show.Gauge) { DoShow(j, colorOpen, open); }
if(Show.Lines && Show.Open) { drawLine(VALUE,TAG+"Open(" + k, colorOpen, 2,tChartPeriod+"["+k+"] Open "+DoubleToStr(VALUE,digits) ) ; }
}

VALUEB   = iHigh( symbol, period, k+1 ) ;
VALUE    = iHigh( symbol, period, k ) ;
VALUEA   = iHigh( symbol, period, k-1 ) ;

if( Show.All || ( !Show.All && (VALUE > VALUEB && VALUE > VALUEA) ) ) 
{
if( !Show.Smart || close > low )
{
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = fFill("High(" + k + ")",fill) ;
PipDiff = ( high - close ) / point ; 
DoColor( close, high  ) ; 
if(Show.Gauge) { DoShow(j, colorHOD,high ); }
if(Show.Lines && Show.High) { drawLine(high,TAG+"High(" + k, colorHOD, 2,tChartPeriod+"["+k+"] High "+DoubleToStr(high,digits) ) ; }
} // if
} // if


VALUEB   = iLow( symbol, period, k+1 ) ;
VALUE    = iLow( symbol, period, k ) ;
VALUEA   = iLow( symbol, period, k-1 ) ;

if( Show.All || ( !Show.All && (VALUE < VALUEB && VALUE < VALUEA) ) ) 
{
if( !Show.Smart || close < high )
{
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = fFill("Low(" + k + ") ",fill) ;
PipDiff = ( close - low ) / point ; 
DoColor( close, low  ) ; 
if(Show.Gauge) { DoShow(j, colorLOD, low); }
if(Show.Lines && Show.Low) { drawLine(low,TAG+"Low(" + k, colorLOD, 2,tChartPeriod+"["+k+"] Low "+DoubleToStr(low,digits) ) ; }
} // if
} // if


VALUEB   = iClose( symbol, period, k+1 ) ;
VALUE    = iClose( symbol, period, k ) ;
VALUEA   = iClose( symbol, period, k-1 ) ;

if( Show.All || ( !Show.All && ((VALUE > VALUEB && VALUE > VALUEA) || (VALUE < VALUEB && VALUE < VALUEA) ) ) )
{
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = fFill("Close(" + k + ") ",fill) ;
PipDiff = ( close - VALUE ) / point ; 
DoColor( close, VALUE  ) ; 
if(Show.Gauge) { DoShow(j, colorClose, VALUE); }
if(Show.Lines && Show.Close) { drawLine(VALUE,TAG+"Close(" + k, colorClose, 2,tChartPeriod+"["+k+"] Close "+DoubleToStr(VALUE,digits) ) ; }
}

if( Show.MidOC )
{
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = fFill("Mid_OC(" + k + ") ",fill) ;
MidOC   = 0.50 * ( VALUE + open ) ; 
PipDiff = ( close - MidOC ) / point ; 
DoColor( close, MidOC  ) ; 
if(Show.Gauge) { DoShow(j, colorMidOC, VALUE); }
if(Show.Lines && Show.Close) { drawLine(MidOC,TAG+"Mid_OC(" + k, colorMidOC, 2,tChartPeriod+"["+k+"] Mid_OC "+DoubleToStr(MidOC,digits) ) ; }
}

VolMsg   = " ";

if(Show.Volume)
{
   TestVol = MathAbs((close - high) / point ) < myThreshold || MathAbs((close - low) / point ) < myThreshold ;
 
   if(k > 0 && TestVol )
   {
      Vol   = iVolume(symbol,period,0);     
      VolHH = iVolume(symbol,period,k);   
   
      if( Vol >=  VolHH ) { VolMsg = "* Higher Volume("+k+")"; VolColor = UpColor ;}
      else { VolMsg = "* Lower Volume("+k+")"; VolColor = DownColor ;}
   } // if
} // if
 
if(VolMsg != " ")
{
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = fFill(VolMsg, 20) ;
DoShowHead(j, VolColor);
}
 
} // for


 
/*
for (int u=0;u<ArraySize(lbl);u++)
{
ObjectCreate(lbl[u],23,0,Time,PRICE_CLOSE);
ObjectSet(lbl[u],OBJPROP_XDISTANCE,610);
ObjectSet(lbl[u],OBJPROP_YDISTANCE,n);
ObjectSetText(lbl[u],lbl2[u],14,"Arial",Green);
n = n+20;
}
*/

   return(0);
  }
//+------------------------------------------------------------------+
  
void DoShowHead( int u, color dsColor )
{
string rlabelH = lbl[u] + "Head" ;
ObjectCreate(rlabelH,23,0,Time[0],PRICE_CLOSE);
ObjectSet(rlabelH, OBJPROP_CORNER, myCorner );
ObjectSet(rlabelH,OBJPROP_XDISTANCE, x001+myChartX);
ObjectSet(rlabelH,OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(rlabelH,lbl2[u],myFontSize,myFont,dsColor);

n = n+20;

return(0);
}
//+------------------------------------------------------------------+
  
void DoShow( int u, color dsColor, double dsPrice )
{
ObjectCreate(lbl[u],23,0,Time,PRICE_CLOSE);
ObjectSet(lbl[u], OBJPROP_CORNER, myCorner );
ObjectSet(lbl[u],OBJPROP_XDISTANCE,x002+myChartX);
ObjectSet(lbl[u],OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(lbl[u],lbl2[u],myFontSize,myFont,dsColor);

string Obj001 = lbl[u] + "price" ;
string sVal = fFill(DoubleToStr(dsPrice,digits), 7)    ;
ObjectCreate(Obj001,23,0,Time[0],PRICE_CLOSE);
ObjectSet(Obj001, OBJPROP_CORNER, myCorner );
ObjectSet(Obj001,OBJPROP_XDISTANCE, x003+myChartX);
ObjectSet(Obj001,OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(Obj001,sVal,myFontSize,myFont,dsColor);


string Obj002 = lbl[u] + "avg" ;
string sDif =  rtadjust( DoubleToStr(PipDiff,0) ) ;
ObjectCreate(Obj002,23,0,Time[0],PRICE_CLOSE);
ObjectSet(Obj002, OBJPROP_CORNER, myCorner );
ObjectSet(Obj002,OBJPROP_XDISTANCE, x004+myChartX);
ObjectSet(Obj002,OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(Obj002,sDif,myFontSize,myFont,pColor);

n = n+20;

   return(0);
  }



//+------------------------------------------------------------------+
  
void DoColor( double c1, double c2 )
{

if(c1 > c2 ) { pColor = Lime ; } else {
if(c1 < c2 ) { pColor = Red ; } else { pColor = Yellow ; } } 

}  

//+------------------------------------------------------------------+
void drawLine(double lvl,string name, color Col,int type,string text)
{
   datetime StartTime;     
        
   StartTime = iTime(symbol,period,k) ;
   
        
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_TREND, 0, StartTime, lvl,Time[0],lvl);
            
  
            ObjectSet(name, OBJPROP_STYLE, LineStyle);
            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,1);
            ObjectSet(name,OBJPROP_RAY,false);
            
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_TREND, 0, StartTime, lvl,Time[0],lvl);
 
            ObjectSet(name, OBJPROP_STYLE, LineStyle);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,1);
            ObjectSet(name,OBJPROP_RAY,false);
          
         }
 
   if(Show.Labels)
   {         
      string Obj0002 = name+"linelbl" ;

      datetime LabelTime = Time[0]+Period()*60*ShiftLabel   ;   
      
      ObjectDelete(Obj0002);
      
      if(ObjectFind(Obj0002) != 0)
      {
         ObjectCreate(Obj0002, OBJ_TEXT, 0, LabelTime, lvl);
         ObjectSetText(Obj0002,text , 8, "Arial", Col);
      }
      else
      {
         ObjectMove(Obj0002, 0, LabelTime, lvl);
      } // if 
                 
   } // if     
         
}
//+------------------------------------------------------------------+
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

//+------------------------------------------------------------------+

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         ",0,f) ;
   
return(FILLED);
}



//+------------------------------------------------------------------+
string rtadjust( string rString )
{
 
 int sl = StringLen(rString) ;
 
 while(true)
 {
 
   if( sl == 5) { break ; } 
   if( sl == 4) { rString = " " + rString ; break ; }    
   if( sl == 3) { rString = "  " + rString ; break ; } 
   if( sl == 2) { rString = "   " + rString ; break ; } 
   if( sl == 1) { rString = "    " + rString ; break ; } 
    
   break ;
 }

return(rString) ;
}       

//+------------------------------------------------------------------+  
 
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+

/*


  
//+------------------------------------------------------------------+
void drawLabel(string name,double lvl,color Color)
{
    if(ObjectFind(name) != 0)
    {
        ObjectCreate(name, OBJ_TEXT, 0, Time[10], lvl);
        ObjectSetText(name, name, 14, "Arial", EMPTY);
        ObjectSet(name, OBJPROP_COLOR, Color);
    }
    else
    {
        ObjectMove(name, 0, Time[10], lvl);
    }
}


Comment(
 
"MathAbs((close - high) / point " , DoubleToStr(MathAbs((close - high) / point),Digits)  , "\n" , 
"MathAbs((close - low) / point " , DoubleToStr(MathAbs((close - low) / point),Digits)  , "\n" ,  

"myThreshold " , DoubleToStr(myThreshold,Digits) , "\n" ,
"TestVol " , TestVol , "\n" , 
"") ;  
 
*/