//+------------------------------------------------------------------+ 
//|   TRO_RSI_DIVERGENCE                                             | 
//|                                                                  | 
//|   Copyright  2011, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/forex.aspx                |  
//| as your forex broker...tell them therumpledone sent you!         |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2011, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 
 
#property indicator_separate_window
#property indicator_buffers 3

extern bool   TurnOff      = false ; 

//extern bool   Send.Mail      = false ;
//extern bool   Sound.Alert    = false ;
extern bool   Show.Lines = true ;
extern bool   Show.All   = true ;

extern int x.offset= 0 ; 
extern int y.offset= 0 ; 

  
extern string myFont       = "Arial Bold" ;
extern int    myFontSize   = 15 ;
  
extern  int   RSI_PERIODS = 2 ;  
extern  int   myDivergenceBars = 100;   
extern  int   NumLinesToShow   = 5; 

extern color MainColor = Black;
extern color Sub1Color = Gold;
extern color GridColor = DimGray; 
 
extern color PosColor = Aqua; 
extern color NegColor = Magenta; 
 
extern int    LineStyle   = STYLE_DOT ;
extern int    LineWidth   = 1 ; 


   
//+------------------------------------------------------------------+

 
string TAG;  
 
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//double ExtMapBuffer3[];

double diff1, diff2 ;

string   tObjName01 , tObjName02, tObjName03 , tObjName04;
string symbol, tChartPeriod,  tShortName, trademsg ;   
 
int      win ;  
 
   int _BarsCount;
   double _CurRangeHigh, _CurRangeLow, _CurRangeCenter;
   
   double _Sub1RangeHigh, _Sub1RangeLow, _Sub1RangeCenter;
   double _Sub1Point, _Sub1Digit;
   double _Sub1Open, _Sub1High, _Sub1Low, _Sub1Close;
   
   double _PipsRatio1;
   
   
   
   double _GridPips, _GridPrice;
   int _i; 
  

   bool  bBuyMain, bSellMain ;

   datetime Trigger ;

   int ND, PD, dindex , NumLines  ;  
   
   bool bND, bPD  ;     
   
   double xPriceMax , xPriceMin    ; 
 
   
//+------------------------------------------------------------------+
int init() 
{

   symbol       =  Symbol() ;

 
   TAG = "rsidiv"  ;
   
   tObjName01 = TAG + "x01";
   tObjName02 = TAG + "x02";
   tObjName03 = TAG + "x03";
   tObjName04 = TAG + "x04";
   
   tShortName = "TRO_RSI(" + RSI_PERIODS + ") DIV"   ;
   
   IndicatorShortName( tShortName );

   SetIndexBuffer( 1, ExtMapBuffer1 );   
   SetIndexBuffer( 0, ExtMapBuffer2 );
//   SetIndexBuffer( 2, ExtMapBuffer3 ); 

if(Show.Lines )
{
   SetIndexStyle( 1, DRAW_LINE, 0, 1, MainColor );
   SetIndexStyle( 0, DRAW_LINE, 0, 1, Sub1Color );
 
}   
else
{
   SetIndexStyle( 1, DRAW_NONE, 0, 1, MainColor );
   SetIndexStyle( 0, DRAW_NONE, 0, 1, Sub1Color );
 
}    

   SetIndexEmptyValue( 0, 0.0 );
   SetIndexEmptyValue( 1, 0.0 );
 


   SetLevelStyle(STYLE_DOT, 1, GridColor) ;
   SetLevelValue(1,100 );
   SetLevelValue(2,90 );   
   SetLevelValue(3,80 );
   SetLevelValue(4,50 );
   SetLevelValue(5,20 ); 
   SetLevelValue(6,10 );
   SetLevelValue(7,0 );        

   deinit() ;
   
   return( 0 );
}

//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
    
//+------------------------------------------------------------------+
int deinit()
  {
        
   ObDeleteObjectsByPrefix(TAG);  
   TRO() ;
   return(0);
  }
  


//+------------------------------------------------------------------+
int start() 
{
  if( TurnOff ) { return(0) ; }
   
   win = WindowFind(tShortName ); 

   deinit() ; 
   dindex = 0 ; 
   NumLines = 0 ;
    

   ArrayInitialize( ExtMapBuffer1, 0.0 );
   ArrayInitialize( ExtMapBuffer2, 0.0 );
 
   _BarsCount = BarsPerWindow() + 1;
   int _FirstBar = FirstVisibleBar();
   int _LastBar = _FirstBar - _BarsCount + 1;
   if ( _LastBar < 0 ) {
      _LastBar = 0;
      _BarsCount = _FirstBar + 1;
   } 
 
for ( _i = _LastBar; _i < _LastBar + _BarsCount; _i ++ ) 
{ 
 
      ExtMapBuffer1[_i] = iClose( symbol, 0, _i ) ;
      
      ExtMapBuffer2[_i] = iRSI(symbol,0,RSI_PERIODS,PRICE_CLOSE, _i );
 
} // for
 
   for(int _j=2; _j < myDivergenceBars + 2 ; _j++) 
   {   
     if( NumLines < NumLinesToShow)
     {      
      if(Show.All)    
      {
         DoDivergence( ExtMapBuffer1[0], ExtMapBuffer1[_j], ExtMapBuffer2[0], ExtMapBuffer2[_j], _j ) ;        
      } 
      else
      {
         if( (ExtMapBuffer1[_j] > ExtMapBuffer1[_j+1] && ExtMapBuffer1[_j] > ExtMapBuffer1[_j-1]) ||
             (ExtMapBuffer1[_j] < ExtMapBuffer1[_j+1] && ExtMapBuffer1[_j] < ExtMapBuffer1[_j-1]) )  
         {
             DoDivergence( ExtMapBuffer1[0], ExtMapBuffer1[_j], ExtMapBuffer2[0], ExtMapBuffer2[_j], _j ) ;        
         } // if
      }  // if(Show.All)      
     } // if( NumLines < NumLinesToShow)
   } // for 
  

   
/*

diff1 = Close[0] - ExtMapBuffer2[0] ; //diff = MathAbs(diff) ;
diff2 = Close[0] - ExtMapBuffer3[0] ;

bSellMain = diff1 > 0 && diff2 > 0 ;
bBuyMain  = diff1 < 0 && diff2 < 0 ;


while(true)
{
   if(bSellMain) { trademsg = "Sell " + symbol + " | Buy " + Sub1Symbol + " & Buy " + Sub2Symbol ; break ;}
   if(bBuyMain ) { trademsg = "Buy " + symbol + " | Sell " + Sub1Symbol + " & Sell " + Sub2Symbol ; break ;}
   trademsg = "Mixed" ; break ;
} // while


if ( Trigger != Time[0] ) 
{
  if( Sound.Alert )
  {
    if( bBuyMain  ) { Alert(symbol," DTB Buy ") ; }
    if( bSellMain ) { Alert(symbol," DTB Sell " ) ; }     
  }
  
  if( Send.Mail )
  {
    if( bBuyMain  ) { SendMail(symbol, " DTB Buy " ); }
    if( bSellMain ) { SendMail(symbol, " DTB Sell " ); }     
  }  
  
Trigger = Time[0] ; 
} 
*/

 
 
/*
   ObjectCreate(tObjName01, OBJ_LABEL, win, 0, 0);// 
   ObjectSetText(tObjName01, trademsg , myFontSize, myFont, MainColor );
   ObjectSet(tObjName01, OBJPROP_CORNER, 1);
   ObjectSet(tObjName01, OBJPROP_XDISTANCE, 10+x.offset); // 
   ObjectSet(tObjName01, OBJPROP_YDISTANCE, 0+y.offset); // 

*/
   WindowRedraw();
   
   return( 0 );
}
//+------------------------------------------------------------------+

void DoDivergence( double curr, double prev, double zP, double zP2, int ii )
{

 
if( curr > prev && zP < zP2) 
{ 
   ND = ii ;  
   NumLines = NumLines + 1 ; 
   DrawIndicatorTrendLine(0,   Time[0], Time[ND], ExtMapBuffer1[0],ExtMapBuffer1[ND], NegColor, LineStyle, LineWidth);
   DrawIndicatorTrendLine(win, Time[0], Time[ND], ExtMapBuffer2[0],ExtMapBuffer2[ND], NegColor, LineStyle, LineWidth);     
}

if( curr < prev && zP > zP2) 
{ 
   PD = ii ; 
   NumLines = NumLines + 1 ;    
   DrawIndicatorTrendLine(0,   Time[0], Time[PD], ExtMapBuffer1[0],ExtMapBuffer1[PD], PosColor, LineStyle, LineWidth);
   DrawIndicatorTrendLine(win, Time[0], Time[PD], ExtMapBuffer2[0],ExtMapBuffer2[PD], PosColor, LineStyle, LineWidth);            
}


}
 


//+------------------------------------------------------------------+
void DrawIndicatorTrendLine(  int dWIN,  datetime x1, datetime x2, double y1, 
                            double y2, color lineColor, int style, int width)
  {
   dindex = dindex + 1 ;
   string label = TAG + dindex;
   ObjectDelete(label);
   ObjectCreate(label, OBJ_TREND, dWIN, x1, y1, x2, y2, 
                0, 0);
   ObjectSet(label, OBJPROP_RAY, 0);
   ObjectSet(label, OBJPROP_COLOR, lineColor);
   ObjectSet(label, OBJPROP_STYLE, style);
   ObjectSet(label, OBJPROP_WIDTH, width);  
   
  }
//+------------------------------------------------------------------+
 
void TRO()
{     
  
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}

//+------------------------------------------------------------------+
/*

Comment( trademsg ) ; 


//+------------------------------------------------------------------+  

void setObject(string labelName,string text,int x,int y,color theColor, string font = "Courier New",int size=10,int angle=0)
{   
      if (ObjectFind(labelName) == -1)
          {
             ObjectCreate(labelName,OBJ_LABEL,win,0,0);
             ObjectSet(labelName,OBJPROP_CORNER,1);
             if (angle != 0)
                  ObjectSet(labelName,OBJPROP_ANGLE,angle);
          }               
       ObjectSet(labelName,OBJPROP_XDISTANCE,x);
       ObjectSet(labelName,OBJPROP_YDISTANCE,y);
       ObjectSetText(labelName,text,size,font,theColor);
}
*/